package dataWrangler;

/*
 * thingBuilder.java
 *
 * Created on March 12, 2003, 11:08 AM
 */

/**
 *
 * @author  rod
 */
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;

public class ThingBuilder {
    
    public Vector thingVector;
    //private Noise noise = new Noise();
    /** Creates a new instance of thingBuilder */
    public ThingBuilder(File f) {
        System.out.println("Parsing XML...");
        SAXBuilder builder = new SAXBuilder();
        Document doc = null;
        try{
            doc = builder.build(f);
        }catch(Exception e){
            e.printStackTrace();
        }
        Element root = doc.getRootElement();
        thingVector = new Vector();
        buildThings(root.getChildren(), "");
        
        System.out.println("Finished (Created +"+thingVector.size()+")");
    }
    
    
    
    private void buildThings(List l, String cPath){
        String rPath = new String(cPath);
        if ((l == null)||(l.size()==0)) return;
        Iterator i = l.iterator();
        while(i.hasNext()){
            Element item = (Element)(i.next());
            List bl = item.getChildren();
            String name = item.getName().trim();
            if(name.equals("branch")){
                item = (Element)(bl.get(0)); // holds directory name
                String np = rPath+"/"+item.getAttributeValue("value").trim();
                bl.remove(0);
                buildThings(bl, np);
            }else if(name.equals("leaf")){
                //                System.out.println("LEAF");
                Thing newThing = new Thing();
                boolean done = false;
                while(!done){
                    if(rPath.startsWith("//")){
                        rPath = rPath.substring(1);
                    }else{
                        done=true;
                    }
                }
                newThing.path=rPath;
                Iterator j = bl.iterator();
                while(j.hasNext()){
                    Element att = (Element)(j.next());
                    String name2 = att.getAttributeValue("name").trim();
                    String value = att.getAttributeValue("value").trim();
                    String ext;
                    if(name2.equals("name")){//filename
                        String fname = value;
                        if (fname.indexOf('.') != -1)
                            ext = value.substring(fname.lastIndexOf('.')+1);
                        else ext="";
                        newThing.filename = fname;
                        newThing.extension = ext;
                    }else if(name2.equals("hitCount")){
                        newThing.hitCount = Integer.valueOf(value).intValue();
                    }else if(name2.equals("size")){
                        newThing.size = Integer.valueOf(value).intValue();
                    }else if(name2.equals("uid")){
                        newThing.uid = Integer.valueOf(value).intValue();
                    }else if(name2.equals("gid")){
                        newThing.gid = Integer.valueOf(value).intValue();
                    }else if(name2.equals("mtime")){
                        newThing.mtime = Long.valueOf(value).longValue();
                    }else if(name2.equals("ctime")){
                        newThing.ctime = Long.valueOf(value).longValue();
                    }else if(name2.equals("title")){
                        newThing.title = value;
                    }else{
                        System.out.println("**Unrecognized attribute: "+name+"**");
                    }
                }
                thingVector.addElement(newThing);
             //   System.out.println(newThing.toString()+"\n");
            }else{
             //   System.out.println("**Ignoring element: "+name+"("+bl.size()+")**");
                if (bl.size() != 0){
                    buildThings(bl, rPath);
                }
            }
        }
    }
}

