/*
 * sbb.java
 *
 * Created on March 13, 2003, 8:38 PM
 */

/**
 *
 * @author  rod
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import dataWrangler.*;

public class sbb extends JFrame implements ActionListener, ChangeListener{
    
    Vector sliderVector;
    Vector protoVector;
    Vector comparisonVector;
    JSlider threshold;
    JTextArea objView;
    JTextField objID;
    JLabel statusMessage;
    JLabel currentFile;
    Vector tv;
    int focused = 0;
    Browser browser;
    Thing prototype;
    
    /** Creates a new instance of sbb */
    public sbb(){
        Rectangle virtualBounds = new Rectangle();
        GraphicsEnvironment ge = GraphicsEnvironment.
        getLocalGraphicsEnvironment();
        GraphicsDevice[] gs = ge.getScreenDevices();
        for (int j = 0; j < gs.length; j++) {
            GraphicsDevice gd = gs[j];
            GraphicsConfiguration[] gc =
            gd.getConfigurations();
            for (int i=0; i < gc.length; i++) {
                virtualBounds = virtualBounds.union(gc[i].getBounds());
            }
        }
        this.setLocation((int)(virtualBounds.getMaxX()-virtualBounds.getWidth()/3), (int)(virtualBounds.getHeight()/3));
        prototype = new Thing();
        setTitle("SBB");
        setVisible(true);
        setResizable(false);
        initComponents();
        pack();
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        sbb main = new sbb();
    }
    
    private void initComponents(){
        Container contentPane = getContentPane();
        JFrame mainFrame;
        JMenuBar menuBar;
        JMenu menu;
        JMenuItem menuItem;
        JPanel panel, subPanel, subSubPanel;
        JLabel label;
        JCheckBox cb;
        JSlider sl;
        JTextArea ta;
        JTextField tf;
        JButton jb;
        
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        
        menuBar = new JMenuBar();
        //File - Open, Exit
        menu = new JMenu("File");
        menu.setMnemonic(KeyEvent.VK_F);
        menuItem = new JMenuItem("Open", KeyEvent.VK_O);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
        menuItem.setActionCommand("MB.FILE");
        menuItem.addActionListener(this);
        menu.add(menuItem);
        menuItem = new JMenuItem("Exit", KeyEvent.VK_X);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, ActionEvent.ALT_MASK));
        menuItem.setActionCommand("MB.EXIT");
        menuItem.addActionListener(this);
        menu.add(menuItem);
        menuBar.add(menu);
        menu = new JMenu("Help");
        menu.setMnemonic(KeyEvent.VK_H);
        menuItem = new JMenuItem("Help", KeyEvent.VK_H);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H, ActionEvent.CTRL_MASK));
        menuItem.setActionCommand("MB.HELP");
        menuItem.addActionListener(this);
        menu.add(menuItem);
        menuItem = new JMenuItem("About", KeyEvent.VK_A);
        menuItem.setActionCommand("MB.ABOUT");
        menuItem.addActionListener(this);
        menu.add(menuItem);
        menuBar.add(menu);
        
        setJMenuBar(menuBar);
        panel = new JPanel();
        panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
        
        //CURRENT FILE / SHOW BROWSER
        subPanel = new JPanel();
        subPanel.setLayout(new BoxLayout(subPanel, BoxLayout.X_AXIS));
        subSubPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        label = new JLabel("Current File:");
        label.setFont(new Font("SansSerif", Font.PLAIN, 10));
        subSubPanel.add(label);
        currentFile = new JLabel("(none)");
        currentFile.setFont(new Font("SansSerif", Font.PLAIN, 10));
        subSubPanel.add(currentFile);
        subPanel.add(subSubPanel);
        JButton showBrowser = new JButton("Show Browser");
        showBrowser.setFont(new Font("SansSerif", Font.PLAIN, 10));
        showBrowser.addActionListener(this);
        showBrowser.setActionCommand("SHOWBROWSER");
        subPanel.add(showBrowser);
        panel.add(subPanel);
        
        int numDimensions = Thing.dimensionNames.length;
        
        subPanel = new JPanel();
        subPanel.setBorder(BorderFactory.createEtchedBorder());
        subPanel.setLayout(new BoxLayout(subPanel, BoxLayout.X_AXIS));
        
        //DIMENSIONS
        subSubPanel = new JPanel();
        subSubPanel.setLayout(new GridLayout(0, 1));
        label = new JLabel("Dimensions", SwingConstants.CENTER);
        label.setFont(new Font("SansSerif", Font.BOLD, 10));
        subSubPanel.add(label);
        for (int i = 0; i < numDimensions; i++){
            label = new JLabel(Thing.dimensionNames[i], SwingConstants.LEFT);
            label.setFont(new Font("SansSerif", Font.PLAIN, 10));
            subSubPanel.add(label);
        }
        subPanel.add(subSubPanel);
        
        //COMPARISON METHODS
        comparisonVector = new Vector();
        subSubPanel = new JPanel();
        subSubPanel.setLayout(new GridLayout(0, 1));
        label = new JLabel("Comparison", SwingConstants.CENTER);
        label.setFont(new Font("SansSerif", Font.BOLD, 10));
        subSubPanel.add(label);
        for (int i = 0; i < numDimensions; i++){
            jb = new JButton(ThingComparer.comparisons[Thing.compareMethod[i]]);
            jb.setFont(new Font("SansSerif", Font.PLAIN, 10));
            jb.setActionCommand("CMP"+i);
            jb.addActionListener(this);
            comparisonVector.addElement(jb);
            subSubPanel.add(jb);
        }
        subPanel.add(subSubPanel);
        
        //PROTOTYPE FIELDS
        subSubPanel = new JPanel();
        subSubPanel.setLayout(new GridLayout(0, 1));
        JPanel subSubSubPanel= new JPanel();
        label = new JLabel("Proto", SwingConstants.CENTER);
        label.setFont(new Font("SansSerif", Font.BOLD, 10));
        subSubSubPanel.add(label);
        jb = new JButton("Clear");
        jb.setFont(new Font("SansSerif", Font.PLAIN, 10));
        jb.setActionCommand("CLEARPROTO");
        jb.addActionListener(this);
        subSubSubPanel.add(jb);
        subSubPanel.add(subSubSubPanel);
        protoVector = new Vector();
        for (int i = 0; i < numDimensions; i++){
            tf = new JTextField(10);
            tf.setActionCommand("PROTO"+i);
            tf.addActionListener(this);
            protoVector.addElement(tf);
            subSubPanel.add(tf);
        }
        subPanel.add(subSubPanel);
        
        //WEIGHT SLIDERS
        subSubPanel = new JPanel();
        subSubPanel.setLayout(new GridLayout(0, 1));
        label = new JLabel("Weight", SwingConstants.CENTER);
        label.setFont(new Font("SansSerif", Font.BOLD, 10));
        subSubPanel.add(label);
        sliderVector = new Vector();
        for (int i = 0; i < numDimensions; i++){
            sl = new JSlider();
            sl.setValue(0);
            sl.addChangeListener(this);
            sliderVector.addElement(sl);
            subSubPanel.add(sl);
        }
        subPanel.add(subSubPanel);
        panel.add(subPanel);
        
        
        //THRESHOLD
        subPanel = new JPanel();
        label = new JLabel("Threshold Similarity:");
        label.setFont(new Font("SansSerif", Font.PLAIN, 10));
        label.setAlignmentX(SwingConstants.LEFT);
        subPanel.add(label);
        threshold = new JSlider();
        threshold.setMajorTickSpacing(50);
        threshold.setPaintTicks(true);
        threshold.setPaintLabels(true);
        threshold.setFont(new Font("SansSerif", Font.PLAIN, 9));
        threshold.addChangeListener(this);
        subPanel.add(threshold);
        panel.add(subPanel);
        
        //FOCUS OBJECT
        subPanel = new JPanel();
        subPanel.setBorder(BorderFactory.createEtchedBorder());
        subPanel.setLayout(new BoxLayout(subPanel, BoxLayout.Y_AXIS));
        subSubPanel = new JPanel();
        label = new JLabel("Focused Object ID:");
        label.setAlignmentX(SwingConstants.LEFT);
        label.setFont(new Font("SansSerif", Font.PLAIN, 10));
        subSubPanel.add(label);
        tf = new JTextField(10);
        tf.setActionCommand("FOCUS");
        tf.addActionListener(this);
        objID = tf;
        subSubPanel.add(tf);
        subPanel.add(subSubPanel);
        subSubPanel = new JPanel();
        ta = new JTextArea(6, 42);
        ta.setEditable(false);
        ta.setLineWrap(true);
        ta.setWrapStyleWord(true);
        ta.setBorder(BorderFactory.createEtchedBorder());
        objView = ta;
        subSubPanel.add(ta);
        subPanel.add(subSubPanel);
        panel.add(subPanel);
        
        //STATUS
        subPanel = new JPanel();
        subPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
        label = new JLabel("Status:");
        label.setFont(new Font("SansSerif", Font.PLAIN, 9));
        statusMessage = new JLabel("Ready.");
        statusMessage.setFont(new Font("SansSerif", Font.PLAIN, 9));
        subPanel.add(label);
        subPanel.add(statusMessage);
        panel.add(subPanel);
        
        contentPane.add(panel);
    }
    
    void openFile(){
        statusMessage.setText("Specify file to open");
        final JFileChooser fc = new JFileChooser();
        int returnVal = fc.showOpenDialog(sbb.this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            statusMessage.setText("Opening "+file.toString());
            statusMessage.updateUI();
            currentFile.setText(file.getName());
            currentFile.updateUI();
            ThingBuilder tb = new ThingBuilder(file);
            tv = tb.thingVector;
            if (browser != null){
                browser.dispose();
            }
            tv.insertElementAt(prototype,0);
            browser = new Browser(this, tv);
            browser.show();
            focused = 1;
            objID.setText("1");
            changeFocusFromMain();
            //objView.setText(((Thing)(tv.elementAt(focused))).toString());
            statusMessage.setText("Created "+tv.size()+" objects.");
        }else{
            statusMessage.setText("Open file operation cancelled");
        }
    }
    
    void changeFocusFromMain(){
        int i = focused;
        try{
            i = (new Integer(objID.getText())).intValue();
        }catch (NumberFormatException nfe){
            i = focused;
        }
        if (i != focused && tv != null){
            if (i >= 0 || i < tv.size()){
                focused = i;
                statusMessage.setText("Set new focus object.");
            }
        }
        objID.setText(new Integer(focused).toString());
        if (tv != null){
            Thing th = (Thing)(tv.elementAt(focused));
            objView.setText(th.toString());
            for(int f = 0; f<protoVector.size(); f++){
                ((JTextField)(protoVector.elementAt(f))).setText(th.getByDimension(f));
            }
        }
        if (browser != null){ //prototype is obj 0
            browser.setFocused(focused);
        }
    }
    
    void changeFocusFromBrowser(int newFocus){
        if (newFocus != focused && tv != null){
            if (newFocus >= 1 || newFocus < tv.size()){
                focused = newFocus;
                statusMessage.setText("Set new focus object.");
            }
        }
        objID.setText(new Integer(focused).toString());
        if (tv != null){
            Thing th = (Thing)(tv.elementAt(focused));
            objView.setText(th.toString());
            for(int i = 0; i<protoVector.size(); i++){
                ((JTextField)(protoVector.elementAt(i))).setText(th.getByDimension(i));
            }
        }
    }
    
    private void showBrowser(){
        if (browser != null && tv != null){
            browser = new Browser(this, tv);
            browser.setFocused(focused);
            browser.show();
        }
    }
    public void stateChanged(ChangeEvent e){
        if(browser != null){
            browser.drawPanel.repaint();
        }
    }
    
    public void actionPerformed(ActionEvent e){
        String cmd = e.getActionCommand();
        System.out.println(cmd);                    /*debug*/
        if (cmd.substring(0,2).equals("MB")){ // menuBar command
            /*FILE, EXIT, SELECT, ABOUT, HELP */
            if (cmd.equals("MB.FILE")){
                openFile();
            }
            if (cmd.equals("MB.EXIT")){
                System.exit(0);
            }
            if (cmd.equals("MB.ABOUT")){
                JDialog dialog = new aboutPanel(this);
                dialog.show();
            }
            if (cmd.equals("MB.HELP")){
                
            }
        }
        if (cmd.equals("FOCUS")){
            changeFocusFromMain();
        }
        if (cmd.equals("SHOWBROWSER")){
            showBrowser();
        }
        if (cmd.startsWith("CMP")){
            int p = Integer.parseInt(cmd.substring(3));
            Thing.compareMethod[p]=ThingComparer.comparisonTransition[Thing.compareMethod[p]];
            ((JButton)(e.getSource())).setText(ThingComparer.comparisons[Thing.compareMethod[p]]);
        }
        if(cmd.equals("CLEARPROTO")){
            //prototype.dispose();
            prototype = new Thing();
            for(int g = 0; g < protoVector.size(); g++){
                ((JTextField)(protoVector.elementAt(g))).setText("");
            }
        }
        if(cmd.startsWith("PROTO")){
            for (int p = 0; p < protoVector.size(); p++){
                prototype.setByDimension(p, ((JTextField)(protoVector.elementAt(p))).getText());
            }
            tv.setElementAt(prototype,0);
            focused=0;
            //objID.setText("[Prototype]");
            changeFocusFromMain();
        }
        if (browser != null){
            browser.drawPanel.repaint();
        }
    }
}

class aboutPanel extends JDialog{
    public aboutPanel(JFrame parent){
        super(parent, "About SBB", true);
        Box b = Box.createVerticalBox();
        b.add(Box.createGlue());
        b.add(new JLabel(" SBB: Similarity Based Browser"));
        b.add(new JLabel(" Author: Rod McFarland"));
        b.add(new JLabel(" Project for CPSC 533B"));
        b.add(new JLabel(" Professor Tamara Munzner"));
        b.add(new JLabel(" The University of British Columbia"));
        b.add(new JLabel(" April 2003"));
        getContentPane().add(b, "Center");
        JPanel p2 = new JPanel();
        JButton ok = new JButton("OK");
        p2.add(ok);
        getContentPane().add(p2, "South");
        ok.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt){
                {dispose();}
                //{setVisible(false);}
                //{System.exit(0);}
            }
        });
        setSize(250,150);
    }
}
